library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity gray is
    Port ( clk : in std_logic;
           reset : in std_logic;
           ce : in std_logic;
           q : out std_logic_vector(6 downto 0));
end gray;

architecture my_arch of gray is
signal q_i: std_logic_vector(7 downto 0);
signal c: std_logic_vector(6 downto 0);
begin
q <= q_i(7 downto 1);
process(clk,reset)
begin
  if(reset = '1')then
    q_i <= "00000000";
  elsif(clk'event and clk = '1')then
    if(ce = '1')then
	   q_i(0) <= not q_i(0);
	   q_i(1) <= q_i(1) xor not q_i(0);
 	   for i in 2 to 7 loop
		  q_i(i) <= q_i(i) xor (c(i-1) and q_i(i-1));
		end loop;
	 else
	   q_i <= q_i;
	 end if;
  end if;
end process;
c(0) <= q_i(0);
g_c: for i in 1 to 6 generate
  c(i) <= c(i-1) and not q_i(i-1);
end generate;
end my_arch;
