library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity vtm_bus is
    port (
-- inputs
        porn: in STD_LOGIC;
        rst_vtmn: in STD_LOGIC;
        is_frc: in STD_LOGIC;
        bc_sta: in STD_LOGIC_VECTOR (11 downto 0);
        j3bus_ctl0: in STD_LOGIC;
-- outputs
        bc_msg: out STD_LOGIC_VECTOR (7 downto 0);
        bc_cmd: out STD_LOGIC_VECTOR (3 downto 0);
        bc_strb: out STD_LOGIC;
        resetn: out STD_LOGIC;
-- inouts
        j3bus_ctl1: inout STD_LOGIC;
        pmc_msg: inout STD_LOGIC_VECTOR (7 downto 0);
        pmc_cmd: inout STD_LOGIC_VECTOR (3 downto 0);
        pmc_sta: inout STD_LOGIC_VECTOR (11 downto 0);
        pmc_strb: inout STD_LOGIC;
        bus_msg: inout STD_LOGIC_VECTOR (7 downto 0);
        bus_cmd: inout STD_LOGIC_VECTOR (3 downto 0);
        bus_sta: inout STD_LOGIC_VECTOR (11 downto 0);
        bus_sta_b: inout STD_LOGIC_VECTOR (11 downto 0);
        bus_strb: inout STD_LOGIC
    );
end vtm_bus;

architecture vtm_bus_arch of vtm_bus is
constant code: std_logic_vector(3 downto 0) := "1010";
constant version: std_logic_vector(1 downto 0) := "01";
signal en_cntr, en_cntr_b,t_j3bus_ctl1,j3bus_ctl1p,frc,valid_cmd: std_logic;
signal n_power_on: std_logic;
signal cntr,cntr_b: unsigned(2 downto 0);
signal sr: std_logic_vector(3 downto 0);
begin
  -- <<enter your statements here>>
resetn <= porn and rst_vtmn;
bussta_gen: for I in 11 downto 0 generate
  bus_sta(I) <= 'Z' when (bc_sta(I) = '1' and (is_frc = '1' or pmc_sta(I) = '1')) else '0';
  bus_sta_b(I) <= 'Z' when (bc_sta(I) = '1' and (is_frc = '1' or pmc_sta(I) = '1')) else '0';
end generate bussta_gen;
bus_msg <= pmc_msg when is_frc = '1' and frc = '1' else (others => 'Z');
bus_cmd <= pmc_cmd when is_frc = '1' and frc = '1' else (others => 'Z');
bus_strb <= pmc_strb when is_frc = '1' and frc = '1' else 'Z';
pmc_sta <= bus_sta when is_frc = '1' and frc = '1' else (others => 'Z');
pmc_msg <= bus_msg when is_frc = '0' and frc = '0' else (others => 'Z');
pmc_cmd <= bus_cmd when is_frc = '0' and frc = '0' else (others => 'Z');
pmc_strb <= bus_strb when is_frc = '0' and frc = '0' else 'Z';
bc_msg <= pmc_msg when is_frc = '1' else bus_msg;
bc_cmd <= pmc_cmd when is_frc = '1' else bus_cmd;
bc_strb <= pmc_strb when is_frc = '1' else bus_strb;
--
j3bus_ctl1 <= j3bus_ctl1p when t_j3bus_ctl1 = '0' else 'Z';
process(j3bus_ctl0,porn)
begin
  if(porn = '0')then
    n_power_on <= '0';
    frc <= not is_frc;
    en_cntr <= '0';
    cntr <= "000";
    sr <= (others => '1');
  elsif(j3bus_ctl0'event and j3bus_ctl0 = '0')then
    sr <= sr(2 downto 0) & j3bus_ctl1;
    if(n_power_on = '0')then
      frc <= not is_frc;
    elsif(cntr = 4 and sr(0) = '1' and valid_cmd = '1')then
      frc <= j3bus_ctl1;
    end if;
    if(cntr = 3 and sr = code)then
      n_power_on <= '1';
      valid_cmd <= '1';
    elsif(en_cntr = '0')then
      valid_cmd <= '0';
    end if;
    if(en_cntr = '0')then
      en_cntr <= j3bus_ctl1 and not sr(0) and not en_cntr_b;
    elsif(cntr = 4)then
      en_cntr <= '0';
    end if;
    if(en_cntr = '0')then
      cntr <= "000";
    else
      cntr <= cntr + 1;
    end if;
  end if;
end process;
process(j3bus_ctl0,porn)
begin
  if(porn = '0')then
    t_j3bus_ctl1 <= '1';
    en_cntr_b <= '0';
    cntr_b <= "000";
    j3bus_ctl1p <= '0';
  elsif(j3bus_ctl0'event and j3bus_ctl0 = '1')then
    t_j3bus_ctl1 <= not en_cntr_b;
    if(cntr = 5)then
      en_cntr_b <= valid_cmd;
    elsif(cntr_b = 7)then
      en_cntr_b <= '0';
    end if;
    if(en_cntr_b = '0')then
      cntr_b <= "000";
    else
      cntr_b <= cntr_b + 1;
    end if;
    case cntr_b is
      when "000" =>
        j3bus_ctl1p <= code(3);
      when "001" =>
        j3bus_ctl1p <= code(2);
      when "010" =>
        j3bus_ctl1p <= code(1);
      when "011" =>
        j3bus_ctl1p <= code(0);
      when "100" =>
        j3bus_ctl1p <= version(1);
      when "101" =>
        j3bus_ctl1p <= version(0);
      when "110" =>
        j3bus_ctl1p <= is_frc;
      when "111" =>
        j3bus_ctl1p <= frc;
      when others =>
        null;
    end case;
  end if;
end process;
end vtm_bus_arch;
